"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class TumourSample(ProtocolElement):
    """
    A tumour sample
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "labSampleId",
        "sampleId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import participant as participant_1_4_0

        return {
            "sampleMorphologies": participant_1_4_0.Morphology,
            "sampleTopographies": participant_1_4_0.Topography,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import participant as participant_1_4_0

        return {
            "diseaseType": participant_1_4_0.diseaseType,
            "haematologicalCancerLineage": participant_1_4_0.HaematologicalCancerLineage,
            "method": participant_1_4_0.Method,
            "preparationMethod": participant_1_4_0.PreparationMethod,
            "product": participant_1_4_0.Product,
            "source": participant_1_4_0.SampleSource,
            "storageMedium": participant_1_4_0.StorageMedium,
            "tumourContent": participant_1_4_0.TumourContent,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import participant as participant_1_4_0

        return {
            "org.gel.models.participant.avro.diseaseType": participant_1_4_0.diseaseType,
            "org.gel.models.participant.avro.HaematologicalCancerLineage": participant_1_4_0.HaematologicalCancerLineage,
            "org.gel.models.participant.avro.Method": participant_1_4_0.Method,
            "org.gel.models.participant.avro.PreparationMethod": participant_1_4_0.PreparationMethod,
            "org.gel.models.participant.avro.Product": participant_1_4_0.Product,
            "org.gel.models.participant.avro.Morphology": participant_1_4_0.Morphology,
            "org.gel.models.participant.avro.Topography": participant_1_4_0.Topography,
            "org.gel.models.participant.avro.SampleSource": participant_1_4_0.SampleSource,
            "org.gel.models.participant.avro.StorageMedium": participant_1_4_0.StorageMedium,
            "org.gel.models.participant.avro.TumourContent": participant_1_4_0.TumourContent,
            "org.gel.models.participant.avro.TumourSample": participant_1_4_0.TumourSample,
        }

    __slots__ = [
        "labSampleId",
        "sampleId",
        "LDPCode",
        "clinicalSampleDateTime",
        "diseaseSubType",
        "diseaseType",
        "haematologicalCancer",
        "haematologicalCancerLineage",
        "maskedPid",
        "method",
        "participantId",
        "participantUid",
        "preparationMethod",
        "product",
        "programmePhase",
        "sampleMorphologies",
        "sampleState",
        "sampleTopographies",
        "sampleType",
        "sampleUid",
        "source",
        "storageMedium",
        "tissueSource",
        "tumourContent",
        "tumourContentPercentage",
        "tumourId",
        "tumourType",
    ]

    def __init__(
        self,
        labSampleId,
        sampleId,
        LDPCode=None,
        clinicalSampleDateTime=None,
        diseaseSubType=None,
        diseaseType=None,
        haematologicalCancer=None,
        haematologicalCancerLineage=None,
        maskedPid=None,
        method=None,
        participantId=None,
        participantUid=None,
        preparationMethod=None,
        product=None,
        programmePhase=None,
        sampleMorphologies=None,
        sampleState=None,
        sampleTopographies=None,
        sampleType=None,
        sampleUid=None,
        source=None,
        storageMedium=None,
        tissueSource=None,
        tumourContent=None,
        tumourContentPercentage=None,
        tumourId=None,
        tumourType=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_4_0.TumourSample model.

        :param labSampleId:
            Lab sample identifier
        :type labSampleId: str
        :param sampleId:
            Sample identifier (e.g, LP00012645_5GH))
        :type sampleId: str
        :param LDPCode:
            LDP Code (Local Delivery Partner)
        :type LDPCode: None | str
        :param clinicalSampleDateTime:
            The time when the sample was received. In the format
            YYYY-MM-DDTHH:MM:SS+0000
        :type clinicalSampleDateTime: None | str
        :param diseaseSubType:
            Disease subtype.         NOTE: Deprecated in GMS
        :type diseaseSubType: None | str
        :param diseaseType:
            Disease type.         NOTE: Deprecated in GMS
        :type diseaseType: None | diseaseType
        :param haematologicalCancer:
            True or false if this sample is of type: Haematological Cancer
        :type haematologicalCancer: None | boolean
        :param haematologicalCancerLineage:
            This is the Haematological cancer lineage of the tumourSample if this
            sample is from a haematological cancer
        :type haematologicalCancerLineage: None | HaematologicalCancerLineage
        :param maskedPid:
            In GMS, this is the maskedPID
        :type maskedPid: None | str
        :param method:
            In GMS, this is how the sample was extracted from the participant
        :type method: None | Method
        :param participantId:
            Participant Id of the sample
        :type participantId: None | str
        :param participantUid:
            Participant UId of the sample
        :type participantUid: None | str
        :param preparationMethod:
            The preparation method of the sample         NOTE: Deprecated in GMS
            in replace of Method and storageMedium record
        :type preparationMethod: None | PreparationMethod
        :param product:
            Product of the sample
        :type product: None | Product
        :param programmePhase:
            Genomics England programme phase
        :type programmePhase: None | str
        :param sampleMorphologies:
            Morphology according to the sample taken
        :type sampleMorphologies: None | list[Morphology]
        :param sampleState:
            In GMS, this is the sampleState as entered by the clinician in TOMs
        :type sampleState: None | str
        :param sampleTopographies:
            Topography according to the sample taken
        :type sampleTopographies: None | list[Topography]
        :param sampleType:
            In GMS, this is the sampleType as entered by the clinician in TOMs
        :type sampleType: None | str
        :param sampleUid:
            In GMS, this is the GUID of the sample
        :type sampleUid: None | str
        :param source:
            Source of the sample
        :type source: None | SampleSource
        :param storageMedium:
            In GMS, this is what solvent/medium the sample was stored in
        :type storageMedium: None | StorageMedium
        :param tissueSource:
            The tissue source of the sample.         NOTE: DEPRECATED IN GMS in
            replace of method record
        :type tissueSource: None | str
        :param tumourContent:
            This is the tumour content
        :type tumourContent: None | TumourContent
        :param tumourContentPercentage:
            This is the tumour content percentage
        :type tumourContentPercentage: None | float
        :param tumourId:
            This is the ID of the tumour from which this tumour sample was taken
            from
        :type tumourId: None | str
        :param tumourType:
            Tumor type.         NOTE: Deprecated in GMS in tumourSample but
            available in tumour record
        :type tumourType: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.4.0"
